<!doctype html>
<html lang="en">
<head>
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/marked/marked.min.js"></script>
    <script src="config.js"></script>

    <meta charset="utf-8" />
    <title>DocHub</title>
</head>

<body>
	<header>
        <h1 id="header">DocIo</h1>
        <nav>
            <details id="links">
                <summary>Menu</summary>
                <ul>
                    <li><a href="./">Home</a></li>
                </ul>
                <div id="navigation"></div>
            </details>
            <details id="toc">
                <summary>Table of Contents</summary>
                <ul id="index">
                    Loading, please wait.
                </ul>
                <div id="navigation"></div>
            </details>
        </nav><hr>
    </header>

    <article>
        <div id="content">
        Loading, please wait.
        </div>
    </article>

    <hr><footer>
        <span id="footer"></span>Page Generated in <span id="time"></span>ms.
    </footer>
    <script>
        const docio_version = '0.2';
        let init_time = (new Date()).getTime()

        if (config == null) {
            config = {
                version: '0.2',

                name: 'DocIo',
                data: 'data/',
                selector: 'title',
                style: {
                    font: 'sans-serif',
                    color: '#111',
                    background: '#fff',
                    menu_open: false,
                    toc_open: true,
                }
            }
            console.error('Your config file was not found or incorrectly configured. Using fallback config.')
        }

        if (config.version != docio_version) {
            console.warn('Your config is not intended for this version of DocIO. Please check the changelog, and reconfigure accordingly.\nIf no breaking changes were made, you can safely ignore this warning.')
        }

        const url = new URL(window.location);
        let title = url.searchParams.get(config.selector);

        $('body').css('font-family', config.style.font);
        $('body').css('color', config.style.color);
        $('body').css('background', config.style.background);
        if (config.style.menu_open) {$('#links').attr('open', '');}
        if (config.style.toc_open) {$('#toc').attr('open', '');}

        function parseinto(element, file) {
            $(element).load(config.data + file, function(responseTxt){
                $(element).html(marked.parse(responseTxt));
            });
        }

        parseinto('#navigation', 'special/header.md')

        if (title == null) {
            $('title').html(config.name)
            $('#header').html(config.name);
            parseinto('#content', 'index.md');
        } else {
            $('title').html(title.replace('_', ' ') + ' - ' + config.name)
            $('#header').html(title.replace('_', ' '));
            parseinto('#content', title + '.md');
        }

        parseinto('#footer', 'special/footer.md');
        const wait_for_toc = window.setInterval(function () {if ($('#content').html() != "Loading, please wait.") {
            let ToC="<ol>";let htitle,link,curElmt,newLine;$("h1").each(function(){curElmt=$(this);htitle=curElmt.text();link="#"+curElmt.attr("id");newLine="<li><a href='"+link+"'>"+htitle+"</a><br/></li>";ToC+=newLine;});$("h2").each(function(){curElmt=$(this);htitle=curElmt.text();link="#"+curElmt.attr("id");newLine="<li><a href='"+link+"'>"+htitle+"</a><br/></li>";ToC+=newLine;});$("h3").each(function(){curElmt=$(this);htitle=curElmt.text();link="#"+curElmt.attr("id");newLine="<li><a href='"+link+"'>"+htitle+"</a><br/></li>";ToC+=newLine;});$("h4").each(function(){curElmt=$(this);htitle=curElmt.text();link="#"+curElmt.attr("id");newLine="<li><a href='"+link+"'>"+htitle+"</a><br/></li>";ToC+=newLine;});$("h5").each(function(){curElmt=$(this);htitle=curElmt.text();link="#"+curElmt.attr("id");newLine="<li><a href='"+link+"'>"+htitle+"</a><br/></li>";ToC+=newLine;});$("h6").each(function(){curElmt=$(this);htitle=curElmt.text();link="#"+curElmt.attr("id");newLine="<li><a href='"+link+"'>"+htitle+"</a><br/></li>";ToC+=newLine;});ToC+="</ol>";$("#index").html(ToC);
            window.clearInterval(wait_for_toc);
        }}, 1000);
        $('#time').html(((new Date()).getTime() - init_time) + 1);
    </script>
</body>
</html>